Index: /code/trunk/data/gui/scripts/MouseControlsMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/MouseControlsMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/MouseControlsMenu.lua	(revision 6746)
@@ -1,16 +1,7 @@
 -- MouseControlsMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    MouseControlsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
+local P = createMenuSheet("MouseControlsMenu")
 
-P.filename = "MouseControlsMenu"
-P.layoutString = "MouseControlsMenu.layout"
-
-function P:init()
+function P.onLoad()
     block = false
     mousenormalscrollbarwindow = tolua.cast(winMgr:getWindow("orxonox/MouseNormalScrollbar"),"CEGUI::Scrollbar")
@@ -104,5 +95,5 @@
 
 function P.MouseControlsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/MultiplayerMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/MultiplayerMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/MultiplayerMenu.lua	(revision 6746)
@@ -1,16 +1,7 @@
 -- MultiplayerMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    MultiplayerMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
+local P = createMenuSheet("MultiplayerMenu")
 
-P.filename = "MultiplayerMenu"
-P.layoutString = "MultiplayerMenu.layout"
-
-function P:init()
+function P.onLoad()
     listbox = winMgr:getWindow("orxonox/MultiplayerLevelListbox")
     preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
@@ -30,5 +21,5 @@
     for k,v in pairs(levelList) do
         item = CEGUI.createListboxTextItem(v)
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
+        item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
         CEGUI.toListbox(listbox):addItem(item)
         if v .. ".oxw" == preselect then
@@ -71,10 +62,10 @@
         orxonox.LevelManager:getInstance():setDefaultLevel(choice:getText() .. ".oxw")
         orxonox.execute(multiplayerMode)
-        hideAllGUIs()
+        hideAllMenuSheets()
     end
 end
 
 function P.MultiplayerBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/MultiplayerOptionsMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/MultiplayerOptionsMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/MultiplayerOptionsMenu.lua	(revision 6746)
@@ -1,17 +1,8 @@
 -- MultiplayerOptionsMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    MultiplayerOptionsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "MultiplayerOptionsMenu"
-P.layoutString = "MultiplayerOptionsMenu.layout"
+local P = createMenuSheet("MultiplayerOptionsMenu")
 
 function P.MultiplayerOptionsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/PickupInventory.lua
===================================================================
--- /code/trunk/data/gui/scripts/PickupInventory.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/PickupInventory.lua	(revision 6746)
@@ -1,15 +1,5 @@
 -- PickupInventory.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-
-if _REQUIREDNAME == nil then
-    PickupInventory = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "PickupInventory"
-P.layoutString = "PickupInventory.layout"
+local P = createMenuSheet("PickupInventory")
 
 P.carrierList = {}
@@ -17,5 +7,5 @@
 P.detailsWindows = {}
 
-function P.init()
+function P.onLoad()
     carrierList = {}
 end
@@ -23,5 +13,5 @@
 function P.show()
     P.window:show() -- TODO: Do this through parent...
-    P.visible = true 
+    P.bVisible = true 
     
     P.createInventory()
@@ -137,5 +127,5 @@
         useButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, textHeight)))
         useButton:setText("use")
-        orxonox.GUIManager:subscribeEventHelper(useButton, "Clicked", P.filename .. ".InventoryUseButton_clicked")
+        orxonox.GUIManager:subscribeEventHelper(useButton, "Clicked", P.name .. ".InventoryUseButton_clicked")
         item:addChildWindow(useButton)
         
@@ -144,5 +134,5 @@
         dropButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, textHeight)))
         dropButton:setText("drop")
-        orxonox.GUIManager:subscribeEventHelper(dropButton, "Clicked", P.filename .. ".InventoryDropButton_clicked")
+        orxonox.GUIManager:subscribeEventHelper(dropButton, "Clicked", P.name .. ".InventoryDropButton_clicked")
         item:addChildWindow(dropButton)
         
@@ -151,5 +141,5 @@
         detailsButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, textHeight)))
         detailsButton:setText("details")
-        orxonox.GUIManager:subscribeEventHelper(detailsButton, "Clicked", P.filename .. ".InventoryDetailsButton_clicked")
+        orxonox.GUIManager:subscribeEventHelper(detailsButton, "Clicked", P.name .. ".InventoryDetailsButton_clicked")
         item:addChildWindow(detailsButton)
     end
@@ -201,5 +191,5 @@
     local window = winMgr:createWindow("TaharezLook/FrameWindow", name)
     window:setSize(CEGUI.UVector2(CEGUI.UDim(0.5,0),CEGUI.UDim(0.4,0)))
-    orxonox.GUIManager:subscribeEventHelper(window, "CloseClicked", P.filename .. ".closeDetailWindow")
+    orxonox.GUIManager:subscribeEventHelper(window, "CloseClicked", P.name .. ".closeDetailWindow")
     
     local root = winMgr:getWindow("orxonox/PickupInventory/Background")
@@ -240,5 +230,5 @@
     useButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, titleHeight)))
     useButton:setText("use")
-    orxonox.GUIManager:subscribeEventHelper(useButton, "Clicked", P.filename .. ".InventoryUseButton_clicked")
+    orxonox.GUIManager:subscribeEventHelper(useButton, "Clicked", P.name .. ".InventoryUseButton_clicked")
     wrapper:addChildWindow(useButton)
     
@@ -247,5 +237,5 @@
     dropButton:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0, titleHeight)))
     dropButton:setText("drop")
-    orxonox.GUIManager:subscribeEventHelper(dropButton, "Clicked", P.filename .. ".InventoryDropButton_clicked")
+    orxonox.GUIManager:subscribeEventHelper(dropButton, "Clicked", P.name .. ".InventoryDropButton_clicked")
     wrapper:addChildWindow(dropButton)
     
Index: /code/trunk/data/gui/scripts/QuestGUI.lua
===================================================================
--- /code/trunk/data/gui/scripts/QuestGUI.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/QuestGUI.lua	(revision 6746)
@@ -1,16 +1,9 @@
-gui = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    QuestGUI = P
-else
-    _G[_REQUIREDNAME] = P
-end
+-- QuestGUI.lua
 
-P.filename = "QuestGUI"
-P.layoutString = "QuestGUI.layout"
+local P = createMenuSheet("QuestGUI")
 
-function P:show()
-    self.window:show() -- TODO: Do this through parent...
-    self.visible = true
+function P.show()
+    P.window:show() -- TODO: Do this through parent...
+    P.visible = true
 
     local questManager = orxonox.QuestManager:getInstance()
@@ -18,5 +11,5 @@
     local questsList = winMgr:getWindow("orxonox/QuestGUI/QuestsList")
 
-    local window = questManager:getQuestGUI(P.filename)
+    local window = questManager:getQuestGUI(P.name)
 
     questsList:addChildWindow(window)
Index: /code/trunk/data/gui/scripts/SettingsMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/SettingsMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/SettingsMenu.lua	(revision 6746)
@@ -1,42 +1,33 @@
 -- SettingsMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    SettingsMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
-
-P.filename = "SettingsMenu"
-P.layoutString = "SettingsMenu.layout"
+local P = createMenuSheet("SettingsMenu")
 
 function P.SettingsGameplayButton_clicked(e)
-    showGUI("GameplayMenu", true)
+    showMenuSheet("GameplayMenu", true)
 end
 
 function P.SettingsMultiplayerOptionsButton_clicked(e)
-    showGUI("MultiplayerOptionsMenu", true)
+    showMenuSheet("MultiplayerOptionsMenu", true)
 end
 
 function P.SettingsControlsButton_clicked(e)
-    showGUI("ControlsMenu", true)
+    showMenuSheet("ControlsMenu", true)
 end
 
 function P.SettingsGraphicsButton_clicked(e)
-    showGUI("GraphicsMenu", true)
+    showMenuSheet("GraphicsMenu", true)
 end
 
 function P.SettingsAudioButton_clicked(e)
-    showGUI("AudioMenu", true)
+    showMenuSheet("AudioMenu", true)
 end
 
 function P.SettingsResetSettingsButton_clicked(e)
     -- reset settings
-    debug("event: reset settings")
+    logMessage(0, "event: reset settings")
 end
 
 function P.SettingsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
Index: /code/trunk/data/gui/scripts/SheetManager.lua
===================================================================
--- /code/trunk/data/gui/scripts/SheetManager.lua	(revision 6746)
+++ /code/trunk/data/gui/scripts/SheetManager.lua	(revision 6746)
@@ -0,0 +1,197 @@
+-- SheetManager.lua
+
+local cursor = CEGUI.MouseCursor:getSingleton()
+local loadedSheets = {}
+local activeMenuSheets = {size = 0, topSheetTuple = nil}
+local menuSheetsRoot = guiMgr:getMenuRootWindow()
+
+-----------------------
+--- Local functions ---
+-----------------------
+
+local function hideCursor()
+    if cursor:isVisible() then
+        cursor:hide()
+    end
+end
+
+local function showCursor()
+    if not cursor:isVisible() and inputMgr:isMouseExclusive() then
+        cursor:show()
+    end
+end
+
+
+------------------------
+--- Global functions ---
+------------------------
+
+-- Loads the GUI with the specified name
+-- The name corresponds to the filename of the *.lua and *.layout files
+-- but without the extension
+function loadSheet(name)
+    -- Check if it has already been loaded
+    local sheet = loadedSheets[name]
+    if sheet == nil then
+        -- Load the sheet
+        sheet = require(name)
+        sheet:load()
+        loadedSheets[name] = sheet
+    end
+    return sheet
+end
+
+-- ?
+function showMenuSheet(name, bHidePrevious, ptr)
+    local sheet = showMenuSheet(name, bHidePrevious)
+    sheet.overlay = ptr
+    return sheet
+end
+
+-- Shows the specified menu sheet and loads it if neccessary
+function showMenuSheet(name, bHidePrevious)
+    if name == "" then
+        return nil
+    end
+    -- Get sheet (or load it)
+    local menuSheet = loadSheet(name)
+
+    -- Use sheet's value if nil was provided
+    if bHidePrevious == nil then
+        bHidePrevious = menuSheet.bHidePrevious
+        assert(bHidePrevious ~= nil)
+    end
+
+    -- Pause game control if this is the first menu to be displayed
+    -- HUGE HACK?
+    if activeMenuSheets.size == 0 then
+        orxonox.HumanController:pauseControl()
+    end
+
+    -- Hide if already displayed (to make sure it is up front in the end)
+    if activeMenuSheets[name] ~= nil then
+        hideMenuSheet(name)
+    end
+
+    -- Add the sheet in a tuple of additional information
+    local sheetTuple =
+    {
+        ["sheet"]          = menuSheet,
+        ["bHidePrevious"]  = bHidePrevious
+    }
+    table.insert(activeMenuSheets, sheetTuple) -- indexed array access
+    activeMenuSheets[name] = sheetTuple -- name access
+    activeMenuSheets.size = activeMenuSheets.size + 1
+    activeMenuSheets.topSheetTuple = sheetTuple
+
+    -- Add sheet to the root window
+    menuSheetsRoot:addChildWindow(menuSheet.window)
+
+    -- Handle input distribution
+    inputMgr:enterState(menuSheet.inputState)
+
+    -- Only change cursor situation if menuSheet.tShowCursor ~= TriBool.Dontcare
+    if menuSheet.tShowCursor == TriBool.True then
+        showCursor()
+    elseif menuSheet.tShowCursor == TriBool.False then
+        hideCursor()
+    end
+
+    -- Hide all previous sheets if necessary
+    if bHidePrevious then
+        for i = 1, activeMenuSheets.size - 1 do
+            activeMenuSheets[i].sheet:hide()
+        end
+    end
+
+    menuSheet:show()
+
+    return menuSheet
+end
+
+function hideMenuSheet(name)
+    local sheetTuple = activeMenuSheets[name]
+    if sheetTuple == nil then
+        return
+    end
+
+    -- Hide the sheet
+    sheetTuple.sheet:hide()
+
+    -- Show sheets that were hidden by the sheet to be removed
+    local i = activeMenuSheets.size
+    -- Only do something if all sheets on top of sheetTuple
+    -- have bHidePrevious == true and sheetTuple.bHidePrevious == true
+    while i > 0 do
+        if activeMenuSheets[i].bHidePrevious then
+            if activeMenuSheets[i] == sheetTuple then
+                i = i - 1
+                while i > 0 do
+                    activeMenuSheets[i].sheet:show()
+                    if activeMenuSheets[i].bHidePrevious then
+                        break
+                    end
+                    i = i - 1
+                end
+            end
+            break
+        end
+        i = i - 1
+    end
+
+    -- Remove sheet with its tuple from the table
+    menuSheetsRoot:removeChildWindow(sheetTuple.sheet.window)
+    table.remove(activeMenuSheets, table.findIndex(activeMenuSheets, sheetTuple))
+    activeMenuSheets[name] = nil
+    activeMenuSheets.size = activeMenuSheets.size - 1
+    activeMenuSheets.topSheetTuple = activeMenuSheets[activeMenuSheets.size]
+
+    -- Leave the input state
+    inputMgr:leaveState(sheetTuple.sheet.inputState)
+    
+    -- CURSOR SHOWING
+    local i = activeMenuSheets.size
+    -- Find top most sheet that doesn't have tShowCusor == TriBool.Dontcare
+    while i > 0 and activeMenuSheets[i].sheet.tShowCursor == TriBool.Dontcare do
+        i = i - 1
+    end
+    if i > 0 and activeMenuSheets[i].sheet.tShowCursor == TriBool.True then
+        showCursor()
+    else
+        hideCursor()
+    end
+
+    -- Resume control if the last menu is hidden
+    if activeMenuSheets.size == 0 then
+        orxonox.HumanController:resumeControl()
+        hideCursor()
+    end
+end
+
+-- Hides all menu GUI sheets
+function hideAllMenuSheets()
+    while activeMenuSheets.size ~= 0 do
+        hideMenuSheet(activeMenuSheets.topSheetTuple.sheet.name)
+    end
+end
+
+function keyESC()
+    -- HUGE, very HUGE hacks!
+    if activeMenuSheets.size == 1 and activeMenuSheets[1].sheet.name == "MainMenu" then
+        orxonox.execute("exit")
+    elseif activeMenuSheets.size > 0 then
+        orxonox.execute("hideGUI "..activeMenuSheets.topSheetTuple.sheet.name)
+    else
+        showMenuSheet("InGameMenu")
+    end
+end
+
+function setBackgroundImage(imageSet, imageName)
+    guiMgr:setBackgroundImage(imageSet, imageName)
+end
+
+----------------------
+--- Initialisation ---
+----------------------
+
+hideCursor()
Index: /code/trunk/data/gui/scripts/SingleplayerMenu.lua
===================================================================
--- /code/trunk/data/gui/scripts/SingleplayerMenu.lua	(revision 6745)
+++ /code/trunk/data/gui/scripts/SingleplayerMenu.lua	(revision 6746)
@@ -1,16 +1,7 @@
 -- SingleplayerMenu.lua
 
-BasicGUI = require("BasicGUI")
-local P = BasicGUI:new() --inherit everything from the gui package
-if _REQUIREDNAME == nil then
-    SingleplayerMenu = P
-else
-    _G[_REQUIREDNAME] = P
-end
+local P = createMenuSheet("SingleplayerMenu")
 
-P.filename = "SingleplayerMenu"
-P.layoutString = "SingleplayerMenu.layout"
-
-function P:init()
+function P.onLoad()
     listbox = winMgr:getWindow("orxonox/SingleplayerLevelListbox")
     preselect = orxonox.LevelManager:getInstance():getDefaultLevel()
@@ -30,5 +21,5 @@
     for k,v in pairs(levelList) do
         item = CEGUI.createListboxTextItem(v)
-        item:setSelectionBrushImage("TaharezLook", "MultiListSelectionBrush")
+        item:setSelectionBrushImage(menuImageSet, "MultiListSelectionBrush")
         CEGUI.toListbox(listbox):addItem(item)
         if v .. ".oxw" == preselect then
@@ -43,10 +34,10 @@
         orxonox.LevelManager:getInstance():setDefaultLevel(choice:getText() .. ".oxw")
         orxonox.execute("startGame")
-        hideAllGUIs()
+        hideAllMenuSheets()
     end
 end
 
 function P.SingleplayerBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideMenuSheet(P.name)
 end
 
